/*
 * muppetcam - uploading webcam viewer
 * by muppet <scott@asofyet.org>, 20-21 june 2002
 *
 * configfile.h - very simple interface to a very simple config file.
 *
 *                you can basically treat this like a one-level perl hash,
 *                string values associated with string keys.
 */

/*
 * NOTE: return values of char * must be free()d
 */

typedef struct _ConfigFile ConfigFile;

/* finds your home directory for you. */
char       * config_file_path             ( char       * dotfile );

/* create a new config file object with no data in it. */
ConfigFile * config_file_new              ();
void         config_file_destroy          ( ConfigFile * cf );

/* read the keys in filename into cf.  replaces existing, does not 
 * delete anything. */
int          config_file_read             ( ConfigFile * cf, 
                                            char       * filename );

/* flush the current contents to disk.  overwrites any existing file. */
int          config_file_write            ( ConfigFile * cf,
                                            char       * filename );

/* returns NULL if the key doesn't exist, or a g_strdup()d copy if it does 
 * -- be sure to free() it. */
char       * config_file_value_get        ( ConfigFile * cf,
                                            char       * key );

/* both the key and value are copied as necessary. */
void         config_file_value_set        ( ConfigFile * cf,
                                            char       * key, 
                                            char       * value );

/* these return boolean, zero if the key doesn't exist */
int          config_file_value_get_double ( ConfigFile * cf, 
                                            char       * key, 
                                            double     * value ); 
int          config_file_value_get_int    ( ConfigFile * cf, 
                                            char       * key, 
                                            int        * value ); 

void         config_file_value_set_double ( ConfigFile * cf, 
                                            char       * key, 
                                            double       value );
void         config_file_value_set_int    ( ConfigFile * cf, 
                                            char       * key, 
                                            int          value );

/* TODO --- add methods to delete keys */
