/*
 * muppetcam - uploading webcam viewer
 * by muppet <scott@asofyet.org>, 20-21 june 2002
 *
 * works with Video4Linux devices and the 3Com HomeConnect USB camera (using 
 * the vicam code from http://homeconnectusb.sourceforge.net)
 *
 * muppetcam.h - various stuff for the app and main window
 */



#define VERSION	"0.9"

#define debug(fmt, args...)	\
	fprintf(stderr, "%s:%d: " fmt, __FILE__, __LINE__ , ## args )

#define whine(fmt, args...)	\
	fprintf(stderr, fmt , ## args )

//#define DOSAVE

/* FIXME should be a user-settable variable */
//#define UPDATE_SPEED	 750
//#define UPDATE_SPEED	 500
#define UPDATE_SPEED	1000	/* one second is good for the vicam, otherwise
				 * things get sluggish. */

#define DEFAULT_UPLOAD_FREQ	15	/* frames */


/****************************************/

typedef struct {
	GtkWidget * hbox;
	GtkWidget * entry;
	GtkWidget * set;
	GtkWidget * reset;
	char      * text;
} Annotation;

typedef struct {
	GtkWidget * window;		/* toplevel                         */
	GtkWidget * canvas;		/* image display canvas             */
	GdkPixmap * pixmap;		/* backing pixmap for canvas        */
	
	GtkWidget * live;		/* live video toggle                */
	GtkWidget * snap;		/* single-frame trigger             */
#ifdef DOSAVE
	GtkWidget * save;		/* save image to file               */
#endif

	GtkWidget * status;		/* status line                      */
	
	Annotation  toptext;		/* annotation for top of image      */
	Annotation  bottomtext;		/* annotation for bottom of image   */

	GtkWidget * upload;		/* upload toggle                    */
	GtkWidget * upload_frame;	/* upload control container         */
	int         upload_freq;	/* number of frames between uploads */
	int         current;		/* current frame number, upload when
					 * this reaches upload_freq         */
	char * hostname;		/* destination server hostname      */
	char * filename;		/* destination file name            */
	GtkWidget * server_dialog;	/* modeless dialog                  */

	Camera * cam;			/* our camera!                      */

	int timeoutid;			/* id of live video timeout handler */
	
} MuppetCamWindow;



MuppetCamWindow * create_and_show_main_window ( Camera * cam );
void set_status ( MuppetCamWindow * mc, const char *fmt, ... );
void upload ( MuppetCamWindow * mc );
int  snap ( MuppetCamWindow * mc );
int  draw ( MuppetCamWindow * mc );

