#include <sys/types.h>
#include <usb.h>

#define MAX_CAMS 8
#define USB_VICAM_VENDOR_ID      0x04c1
#define USB_VICAM_PRODUCT_ID     0x009d

/* These are the "bad" id's to get.  We don't
   support the HomeConnect WebCam Lite. */
#define USB_3COM_LITE_VENDOR_ID	0x0506 
#define USB_3COM_LITE_PRODUCT_ID	0x00df 

#define ERR_NO_VICAMS 1
#define ERR_LITE_NOT_SUPPORTED 2

typedef struct vicam_device
{
	struct usb_device *usbdev;			/* The USB device for this vicam */
	int cam_id;						/* Unique # indicating how many cams were found before this one */
	usb_dev_handle *handle;		/* Valid only if the device has been claimed */
	int claimed;
} vicam_device;



int vicam_usb_init();
int vicam_get_cam_count();
int vicam_claim( int camId );
int vicam_release( int camId );
void vicam_acquire( int camId, char *buf, char gain, short shutterFraction,
		short width, short height, int color);
long vicam_set_led( int camId, int state );
void vicam_decode_color( char *data, char *rgb, int width, int height );
void vicam_set_debug( int level );
